//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                           ZH_Dynamic_Arrays_Lib 0-80108.mq4|
//|                                                                                                                                                           Copyright  Zhunko               |
//|08.01.2008                                                                                                                                                 F ZHUNKO vadim@zhunko.ru        |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|      .                                                                                                                                          |
//|     ,   .                                                                                                                              |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//+      . +
//| 1. "     ".==========================================================================================================================+
//|   BoolArrayDynamicDimension2 ( true/false - /,  true/false - /   ,                                        |
//|                                true/false - /        ,    ,                 |
//|                                  ,     ,     ,    /,             |
//|                               1-        );                                                                                            |
//|   int BoolArrayDynamicDimension2 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int Cell_0, int Cell_1, bool Value, bool Array[]);            |
//| 2. "     ".--------------------------------------------------------------------------------------------------------------------------+
//|   BoolArrayDynamicDimension3 ( true/false - /,  true/false - /   ,                                        |
//|                                true/false - /        ,    ,                 |
//|                                  ,    ,     ,     ,           |
//|                                   ,    /, 1-        );                     |
//|   int BoolArrayDynamicDimension3 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int Cell_0, int Cell_1,                  |
//|                                   int Cell_2, bool Value, bool Array[]);                                                                                                                   |
//| 3. "     ".-----------------------------------------------------------------------------------------------------------------------+
//|   BoolArrayDynamicDimension4 ( true/false - /,  true/false - /   ,                                        |
//|                                true/false - /        ,    ,                 |
//|                                  ,    ,    ,     ,       |
//|                                   ,     ,     ,    /,                |
//|                               1-        );                                                                                            |
//|   int BoolArrayDynamicDimension4 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                     |
//|                                   int Cell_0, int Cell_1, int Cell_2, int Cell_3, bool Value, bool Array[]);                                                                               |
//| 4. "     ".--------------------------------------------------------------------------------------------------------------------------+
//|   BoolArrayDynamicDimension5 ( true/false - /,  true/false - /   ,                                        |
//|                                true/false - /        ,    ,                 |
//|                                  ,    ,    ,    ,  |
//|                                   ,     ,     ,     ,                |
//|                                   ,    /, 1-        );                  |
//|   int BoolArrayDynamicDimension5 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                     |
//|                                   int SizeDimension_4, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, bool Value, bool Array[]);                                              |
//| 5. "     ".-------------------------------------------------------------------------------------------------------------------------+
//|   BoolArrayDynamicDimension6 ( true/false - /,  true/false - /   ,                                        |
//|                                true/false - /        ,    ,                 |
//|                                  ,    ,    ,    ,  |
//|                                  ,     ,     ,     ,               |
//|                                   ,     ,     ,    /,              |
//|                               1-        );                                                                                            |
//|   int BoolArrayDynamicDimension6 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                     |
//|                                   int SizeDimension_4, int SizeDimension_5, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, int Cell_5, bool Value, bool Array[]);             |
//+       . +
//| 6. "      ".---------------------------------------------------------------------------------------------------------------------+
//|   doubleArrayDynamicDimension2 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,     ,     ,    /,           |
//|                                 1-        );                                                                                          |
//|   int doubleArrayDynamicDimension2 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int Cell_0, int Cell_1, double Value, double Array[]);      |
//| 7. "      ".---------------------------------------------------------------------------------------------------------------------+
//|   doubleArrayDynamicDimension3 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,     ,     ,         |
//|                                     ,    /, 1-        );                   |
//|   int doubleArrayDynamicDimension3 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int Cell_0, int Cell_1, int Cell_2,    |
//|                                     double Value, double Array[]);                                                                                                                         |
//| 8. "      ".------------------------------------------------------------------------------------------------------------------+
//|   doubleArrayDynamicDimension4 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,     ,     |
//|                                     ,     ,     ,    /,              |
//|                                 1-        );                                                                                          |
//|  int doubleArrayDynamicDimension4 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3, int Cell_0,        |
//|                                    int Cell_1, int Cell_2, int Cell_3, double Value, double Array[]);                                                                                      |
//| 9. "      ".---------------------------------------------------------------------------------------------------------------------+
//|   doubleArrayDynamicDimension5 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,    ,|
//|                                     ,     ,     ,     ,              |
//|                                     ,    /, 1-        );                |
//|   int doubleArrayDynamicDimension5 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                   |
//|                                     int SizeDimension_4, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, double Value, double Array[]);                                        |
//|10. "      ".--------------------------------------------------------------------------------------------------------------------+
//|   doubleArrayDynamicDimension6 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,    ,|
//|                                    ,     ,     ,     ,             |
//|                                     ,     ,     ,    /,            |
//|                                 1-        );                                                                                          |
//|   int doubleArrayDynamicDimension6 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                   |
//|                                     int SizeDimension_4, int SizeDimension_5, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, int Cell_5, double Value, double Array[]);       |
//+      .+
//|11. "     ".-----------------------------------------------------------------------------------------------------------------------+
//|   IntArrayDynamicDimension2 ( true/false - /,  true/false - /   ,                                         |
//|                               true/false - /        ,    ,                  |
//|                                 ,     ,     ,    /,              |
//|                              1-        );                                                                                             |
//|   int IntArrayDynamicDimension2 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int Cell_0, int Cell_1, int Value, int Array[]);               |
//|12. "     ".-----------------------------------------------------------------------------------------------------------------------+
//|   IntArrayDynamicDimension3 ( true/false - /,  true/false - /   ,                                         |
//|                               true/false - /        ,    ,                  |
//|                                 ,    ,     ,     ,            |
//|                                  ,    /, 1-        );                      |
//|   int IntArrayDynamicDimension3 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int Cell_0, int Cell_1, int Cell_2,       |
//|                                  int Value, int Array[]);                                                                                                                                  |
//|13. "     ".--------------------------------------------------------------------------------------------------------------------+
//|   IntArrayDynamicDimension4 ( true/false - /,  true/false - /   ,                                         |
//|                               true/false - /        ,    ,                  |
//|                                 ,    ,    ,     ,        |
//|                                  ,     ,     ,    /,                 |
//|                              1-        );                                                                                             |
//|   int IntArrayDynamicDimension4 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3, int Cell_0,          |
//|                                  int Cell_1, int Cell_2, int Cell_3, int Value, int Array[]);                                                                                              |
//|14. "     ".-----------------------------------------------------------------------------------------------------------------------+
//|   IntArrayDynamicDimension5 ( true/false - /,  true/false - /   ,                                         |
//|                               true/false - /        ,    ,                  |
//|                                 ,    ,    ,    ,   |
//|                                  ,     ,     ,     ,                 |
//|                                  ,    /, 1-        );                   |
//|   int IntArrayDynamicDimension5 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3, int SizeDimension_4, |
//|                                  int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, int Value, int Array[]);                                                                      |
//|15. "     ".----------------------------------------------------------------------------------------------------------------------+
//|   IntArrayDynamicDimension6 ( true/false - /,  true/false - /   ,                                         |
//|                               true/false - /        ,    ,                  |
//|                                 ,    ,    ,    ,   |
//|                                 ,     ,     ,     ,                |
//|                                  ,     ,     ,    /,               |
//|                              1-        );                                                                                             |
//|   int IntArrayDynamicDimension6 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                      |
//|                                  int SizeDimension_4, int SizeDimension_5, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, int Cell_5, int Value, int Array[]);                |
//+      .+
//|16. "     ".--------------------------------------------------------------------------------------------------------------------------+
//|   StringArrayDynamicDimension2 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,     ,     ,    /,           |
//|                                 1-        );                                                                                          |
//|   string StringArrayDynamicDimension2 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int Cell_0, int Cell_1, string Value, string Array[]);   |
//|17. "     ".--------------------------------------------------------------------------------------------------------------------------+
//|   StringArrayDynamicDimension3 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,     ,     ,         |
//|                                     ,    /, 1-        );                   |
//|   string StringArrayDynamicDimension3 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int Cell_0, int Cell_1,             |
//|                                        int Cell_2, string Value, string Array[]);                                                                                                          |
//|18. "     ".-----------------------------------------------------------------------------------------------------------------------+
//|   StringArrayDynamicDimension4 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,     ,     |
//|                                     ,     ,     ,    /,              |
//|                                 1-        );                                                                                          |
//|   string StringArrayDynamicDimension4 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3, int Cell_0,    |
//|                                        int Cell_1, int Cell_2, int Cell_3, string Value, string Array[]);                                                                                  |
//|19. "     ".--------------------------------------------------------------------------------------------------------------------------+
//|   StringArrayDynamicDimension5 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,    ,|
//|                                     ,     ,     ,     ,              |
//|                                     ,    /, 1-        );                |
//|   string StringArrayDynamicDimension5 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                |
//|                                        int SizeDimension_4, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, string Value, string Array[]);                                     |
//|20. "     ".-------------------------------------------------------------------------------------------------------------------------+
//|   StringArrayDynamicDimension6 ( true/false - /,  true/false - /   ,                                      |
//|                                  true/false - /        ,    ,               |
//|                                    ,    ,    ,    ,|
//|                                    ,     ,     ,     ,             |
//|                                     ,     ,     ,    /,            |
//|                                 1-        );                                                                                          |
//|   string StringArrayDynamicDimension6 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3,                |
//|                                        int SizeDimension_4, int SizeDimension_5, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Cell_4, int Cell_5, string Value, string Array[]);    |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2006 Zhunko"
#property link      "vadim@zhunko.ru"
#property library
//      .
//1=== "     ".===========================================================================================================================
int BoolArrayDynamicDimension2 (bool  Write_Read,      //  true/false - /.
                                bool  CheckingERROR,   //  true/false - /   .
                                bool  PRINT,           //  true/false - /        .
                                int   SizeDimension_0, //    .
                                int   SizeDimension_1, //    .
                                int   Cell_0,          //     .
                                int   Cell_1,          //     .
                                bool  Value,           //    /.
                                bool& Array[])         // 1-        .
 {
  int a, b;      //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  //----  .-------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension2()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1);
  Cell = SizeDim_1 * Cell_0 + Cell_1;          //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     Print ("Array[", a,"][", b, "] = ", Array[SizeDim_1 * a + b]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//2=== "     ".============================================================================================================================
int BoolArrayDynamicDimension3 (bool  Write_Read,      //  true/false - /.
                                bool  CheckingERROR,   //  true/false - /   .
                                bool  PRINT,           //  true/false - /        .
                                int   SizeDimension_0, //    .
                                int   SizeDimension_1, //    .
                                int   SizeDimension_2, //    .
                                int   Cell_0,          //     .
                                int   Cell_1,          //     .
                                int   Cell_2,          //     .
                                bool  Value,           //    /.
                                bool& Array[])         // 1-        .
 {
  int a, b, c;   //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  int SizeDim_2; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension3()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2);
  Cell = SizeDim_1 * SizeDim_2 * Cell_0 + SizeDim_2 * Cell_1 + Cell_2; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      Print ("Array[", a,"][", b, "][", c, "] = ", Array[SizeDim_1 * SizeDim_2 * a + SizeDim_2 * b + c]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//3=== "     ".=========================================================================================================================
int BoolArrayDynamicDimension4 (bool  Write_Read,      //  true/false - /.
                                bool  CheckingERROR,   //  true/false - /   .
                                bool  PRINT,           //  true/false - /        .
                                int   SizeDimension_0, //    .
                                int   SizeDimension_1, //    .
                                int   SizeDimension_2, //    .
                                int   SizeDimension_3, //    .
                                int   Cell_0,          //     .
                                int   Cell_1,          //     .
                                int   Cell_2,          //     .
                                int   Cell_3,          //     .
                                bool& Value,           //    /.
                                bool& Array[])         // 1-        .
 {
  int a, b, c, d; //   .
  int Cell;       //     .
  int SizeDim_1;  //  .
  int SizeDim_2;  //  .
  int SizeDim_3;  //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension4()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * Cell_0 + SizeDim_2 * SizeDim_3 * Cell_1 + SizeDim_3 * Cell_2 + Cell_3; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       Print ("Array[", a,"][", b, "][", c, "][", d, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * a + SizeDim_2 * SizeDim_3 * b + SizeDim_3 * c + d]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//4=== "     ".============================================================================================================================
int BoolArrayDynamicDimension5 (bool  Write_Read,      //  true/false - /.
                                bool  CheckingERROR,   //  true/false - /   .
                                bool  PRINT,           //  true/false - /        .
                                int   SizeDimension_0, //    .
                                int   SizeDimension_1, //    .
                                int   SizeDimension_2, //    .
                                int   SizeDimension_3, //    .
                                int   SizeDimension_4, //    .
                                int   Cell_0,          //     .
                                int   Cell_1,          //     .
                                int   Cell_2,          //     .
                                int   Cell_3,          //     .
                                int   Cell_4,          //     .
                                bool& Value,           //    /.
                                bool& Array[])         // 1-        .
 {
  int a, b, c, d, e; //   .
  int Cell;          //     .
  int SizeDim_1;     //  .
  int SizeDim_2;     //  .
  int SizeDim_3;     //  .
  int SizeDim_4;     //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension5()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
   }
  //----        .----------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_1 + SizeDim_3 * SizeDim_4 * Cell_2 + SizeDim_4 * Cell_3 + Cell_4; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * b + SizeDim_3 * SizeDim_4 * c + SizeDim_4 * d + e]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//5=== "     ".===========================================================================================================================
int BoolArrayDynamicDimension6 (bool  Write_Read,      //  true/false - /.
                                bool  CheckingERROR,   //  true/false - /   .
                                bool  PRINT,           //  true/false - /        .
                                int   SizeDimension_0, //    .
                                int   SizeDimension_1, //    .
                                int   SizeDimension_2, //    .
                                int   SizeDimension_3, //    .
                                int   SizeDimension_4, //    .
                                int   SizeDimension_5, //    .
                                int   Cell_0,          //     .
                                int   Cell_1,          //     .
                                int   Cell_2,          //     .
                                int   Cell_3,          //     .
                                int   Cell_4,          //     .
                                int   Cell_5,          //     .
                                bool& Value,           //    /.
                                bool& Array[])         // 1-        .
 {
  int a, b, c, d, e, f; //   .
  int Cell;             //     .
  int SizeDim_1;        //  .
  int SizeDim_2;        //  .
  int SizeDim_3;        //  .
  int SizeDim_4;        //  .
  int SizeDim_5;        //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    if (SizeDimension_5 < 0) //     .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n SizeDimension_5 = ", SizeDimension_5, " .");
      Print (" SizeDimension_5 = ", SizeDimension_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    if (Cell_5 < 0) //       .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n    Cell_5 = ", Cell_5, " .");
      Print ("    Cell_5 = ", Cell_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
    if (Cell_5 > (SizeDimension_5 - 1)) //      .
     {
      Comment (" \"BoolArrayDynamicDimension6()\".\n   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5, ".");
      Print ("   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  if (SizeDimension_5 == 0) SizeDim_5 = 1;
  else SizeDim_5 = SizeDimension_5;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_1 + SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_2 + SizeDim_4 * SizeDim_5 * Cell_3 + SizeDim_5 * Cell_4 + Cell_5; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        for (f = 0; f < SizeDim_5; f++)
         Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "][", f, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * b + SizeDim_3 * SizeDim_4 * SizeDim_5 * c + SizeDim_4 * SizeDim_5 * d + SizeDim_5 * e + f]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//       .
//6=== "      ".=======================================================================================================================
int doubleArrayDynamicDimension2 (bool    Write_Read,      //  true/false - /.
                                  bool    CheckingERROR,   //  true/false - /   .
                                  bool    PRINT,           //  true/false - /        .
                                  int     SizeDimension_0, //    .
                                  int     SizeDimension_1, //    .
                                  int     Cell_0,          //     .
                                  int     Cell_1,          //     .
                                  double& Value,           //    /.
                                  double& Array[])         // 1-        .
 {
  int a, b;      //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension2()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1);
  Cell = SizeDim_1 * Cell_0 + Cell_1;          //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     Print ("Array[", a,"][", b, "] = ", Array[SizeDim_1 * a + b]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//7=== "      ".=======================================================================================================================
int doubleArrayDynamicDimension3 (bool    Write_Read,      //  true/false - /.
                                  bool    CheckingERROR,   //  true/false - /   .
                                  bool    PRINT,           //  true/false - /        .
                                  int     SizeDimension_0, //    .
                                  int     SizeDimension_1, //    .
                                  int     SizeDimension_2, //    .
                                  int     Cell_0,          //     .
                                  int     Cell_1,          //     .
                                  int     Cell_2,          //     .
                                  double& Value,           //    /.
                                  double& Array[])         // 1-        .
 {
  int a, b, c;   //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  int SizeDim_2; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension3()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2);
  Cell = SizeDim_1 * SizeDim_2 * Cell_0 + SizeDim_2 * Cell_1 + Cell_2; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      Print ("Array[", a,"][", b, "][", c, "] = ", Array[SizeDim_1 * SizeDim_2 * a + SizeDim_2 * b + c]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//8=== "      ".====================================================================================================================
int doubleArrayDynamicDimension4 (bool    Write_Read,      //  true/false - /.
                                  bool    CheckingERROR,   //  true/false - /   .
                                  bool    PRINT,           //  true/false - /        .
                                  int     SizeDimension_0, //    .
                                  int     SizeDimension_1, //    .
                                  int     SizeDimension_2, //    .
                                  int     SizeDimension_3, //    .
                                  int     Cell_0,          //     .
                                  int     Cell_1,          //     .
                                  int     Cell_2,          //     .
                                  int     Cell_3,          //     .
                                  double& Value,           //    /.
                                  double& Array[])         // 1-        .
 {
  int a, b, c, d; //   .
  int Cell;       //     .
  int SizeDim_1;  //  .
  int SizeDim_2;  //  .
  int SizeDim_3;  //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension4()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * Cell_0 + SizeDim_2 * SizeDim_3 * Cell_1 + SizeDim_3 * Cell_2 + Cell_3; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       Print ("Array[", a,"][", b, "][", c, "][", d, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * a + SizeDim_2 * SizeDim_3 * b + SizeDim_3 * c + d]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//9=== "      ".=======================================================================================================================
int doubleArrayDynamicDimension5 (bool    Write_Read,      //  true/false - /.
                                  bool    CheckingERROR,   //  true/false - /   .
                                  bool    PRINT,           //  true/false - /        .
                                  int     SizeDimension_0, //    .
                                  int     SizeDimension_1, //    .
                                  int     SizeDimension_2, //    .
                                  int     SizeDimension_3, //    .
                                  int     SizeDimension_4, //    .
                                  int     Cell_0,          //     .
                                  int     Cell_1,          //     .
                                  int     Cell_2,          //     .
                                  int     Cell_3,          //     .
                                  int     Cell_4,          //     .
                                  double& Value,           //    /.
                                  double& Array[])         // 1-        .
 {
  int a, b, c, d, e; //   .
  int Cell;          //     .
  int SizeDim_1;     //  .
  int SizeDim_2;     //  .
  int SizeDim_3;     //  .
  int SizeDim_4;     //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension5()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_1 + SizeDim_3 * SizeDim_4 * Cell_2 + SizeDim_4 * Cell_3 + Cell_4; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * b + SizeDim_3 * SizeDim_4 * c + SizeDim_4 * d + e]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//10== "      ".======================================================================================================================
int doubleArrayDynamicDimension6 (bool    Write_Read,      //  true/false - /.
                                  bool    CheckingERROR,   //  true/false - /   .
                                  bool    PRINT,           //  true/false - /        .
                                  int     SizeDimension_0, //    .
                                  int     SizeDimension_1, //    .
                                  int     SizeDimension_2, //    .
                                  int     SizeDimension_3, //    .
                                  int     SizeDimension_4, //    .
                                  int     SizeDimension_5, //    .
                                  int     Cell_0,          //     .
                                  int     Cell_1,          //     .
                                  int     Cell_2,          //     .
                                  int     Cell_3,          //     .
                                  int     Cell_4,          //     .
                                  int     Cell_5,          //     .
                                  double& Value,           //    /.
                                  double& Array[])         // 1-        .
 {
  int a, b, c, d, e, f; //   .
  int Cell;             //     .
  int SizeDim_1;        //  .
  int SizeDim_2;        //  .
  int SizeDim_3;        //  .
  int SizeDim_4;        //  .
  int SizeDim_5;        //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    if (SizeDimension_5 < 0) //     .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n SizeDimension_5 = ", SizeDimension_5, " .");
      Print (" SizeDimension_5 = ", SizeDimension_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    if (Cell_5 < 0) //       .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n    Cell_5 = ", Cell_5, " .");
      Print ("    Cell_5 = ", Cell_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
    if (Cell_5 > (SizeDimension_5 - 1)) //      .
     {
      Comment (" \"doubleArrayDynamicDimension6()\".\n   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5, ".");
      Print ("   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  if (SizeDimension_5 == 0) SizeDim_5 = 1;
  else SizeDim_5 = SizeDimension_5;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_1 + SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_2 + SizeDim_4 * SizeDim_5 * Cell_3 + SizeDim_5 * Cell_4 + Cell_5; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        for (f = 0; f < SizeDim_5; f++)
         Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "][", f, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * b + SizeDim_3 * SizeDim_4 * SizeDim_5 * c + SizeDim_4 * SizeDim_5 * d + SizeDim_5 * e + f]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//      .
//11== "     ".=========================================================================================================================
int IntArrayDynamicDimension2 (bool  Write_Read,      //  true/false - /.
                               bool  CheckingERROR,   //  true/false - /   .
                               bool  PRINT,           //  true/false - /        .
                               int   SizeDimension_0, //    .
                               int   SizeDimension_1, //    .
                               int   Cell_0,          //     .
                               int   Cell_1,          //     .
                               int&  Value,           //    /.
                               int&  Array[])         // 1-        .
 {
  int a, b;      //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension2()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1);
  Cell = SizeDim_1 * Cell_0 + Cell_1;          //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     Print ("Array[", a,"][", b, "] = ", Array[SizeDim_1 * a + b]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//12== "     ".=========================================================================================================================
int IntArrayDynamicDimension3 (bool  Write_Read,      //  true/false - /.
                               bool  CheckingERROR,   //  true/false - /   .
                               bool  PRINT,           //  true/false - /        .
                               int   SizeDimension_0, //    .
                               int   SizeDimension_1, //    .
                               int   SizeDimension_2, //    .
                               int   Cell_0,          //     .
                               int   Cell_1,          //     .
                               int   Cell_2,          //     .
                               int&  Value,           //    /.
                               int&  Array[])         // 1-        .
 {
  int a, b, c;   //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  int SizeDim_2; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension3()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2);
  Cell = SizeDim_1 * SizeDim_2 * Cell_0 + SizeDim_2 * Cell_1 + Cell_2; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      Print ("Array[", a,"][", b, "][", c, "] = ", Array[SizeDim_1 * SizeDim_2 * a + SizeDim_2 * b + c]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//13== "     ".======================================================================================================================
int IntArrayDynamicDimension4 (bool  Write_Read,      //  true/false - /.
                               bool  CheckingERROR,   //  true/false - /   .
                               bool  PRINT,           //  true/false - /        .
                               int   SizeDimension_0, //    .
                               int   SizeDimension_1, //    .
                               int   SizeDimension_2, //    .
                               int   SizeDimension_3, //    .
                               int   Cell_0,          //     .
                               int   Cell_1,          //     .
                               int   Cell_2,          //     .
                               int   Cell_3,          //     .
                               int&  Value,           //    /.
                               int&  Array[])         // 1-        .
 {
  int a, b, c, d; //   .
  int Cell;       //     .
  int SizeDim_1;  //  .
  int SizeDim_2;  //  .
  int SizeDim_3;  //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension4()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * Cell_0 + SizeDim_2 * SizeDim_3 * Cell_1 + SizeDim_3 * Cell_2 + Cell_3; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       Print ("Array[", a,"][", b, "][", c, "][", d, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * a + SizeDim_2 * SizeDim_3 * b + SizeDim_3 * c + d]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//14== "     ".=========================================================================================================================
int IntArrayDynamicDimension5 (bool  Write_Read,      //  true/false - /.
                               bool  CheckingERROR,   //  true/false - /   .
                               bool  PRINT,           //  true/false - /        .
                               int   SizeDimension_0, //    .
                               int   SizeDimension_1, //    .
                               int   SizeDimension_2, //    .
                               int   SizeDimension_3, //    .
                               int   SizeDimension_4, //    .
                               int   Cell_0,          //     .
                               int   Cell_1,          //     .
                               int   Cell_2,          //     .
                               int   Cell_3,          //     .
                               int   Cell_4,          //     .
                               int&  Value,           //    /.
                               int&  Array[])         // 1-        .
 {
  int a, b, c, d, e; //   .
  int Cell;          //     .
  int SizeDim_1;     //  .
  int SizeDim_2;     //  .
  int SizeDim_3;     //  .
  int SizeDim_4;     //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension5()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_1 + SizeDim_3 * SizeDim_4 * Cell_2 + SizeDim_4 * Cell_3 + Cell_4; //     .
  //----/.----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * b + SizeDim_3 * SizeDim_4 * c + SizeDim_4 * d + e]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//15== "     ".========================================================================================================================
int IntArrayDynamicDimension6 (bool  Write_Read,      //  true/false - /.
                               bool  CheckingERROR,   //  true/false - /   .
                               bool  PRINT,           //  true/false - /        .
                               int   SizeDimension_0, //    .
                               int   SizeDimension_1, //    .
                               int   SizeDimension_2, //    .
                               int   SizeDimension_3, //    .
                               int   SizeDimension_4, //    .
                               int   SizeDimension_5, //    .
                               int   Cell_0,          //     .
                               int   Cell_1,          //     .
                               int   Cell_2,          //     .
                               int   Cell_3,          //     .
                               int   Cell_4,          //     .
                               int   Cell_5,          //     .
                               int&  Value,           //    /.
                               int&  Array[])         // 1-        .
 {
  int a, b, c, d, e, f; //   .
  int Cell;             //     .
  int SizeDim_1;        //  .
  int SizeDim_2;        //  .
  int SizeDim_3;        //  .
  int SizeDim_4;        //  .
  int SizeDim_5;        //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return (-1);
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return (-1);
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return (-1);
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return (-1);
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return (-1);
     }
    if (SizeDimension_5 < 0) //     .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n SizeDimension_5 = ", SizeDimension_5, " .");
      Print (" SizeDimension_5 = ", SizeDimension_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return (-1);
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return (-1);
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return (-1);
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return (-1);
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return (-1);
     }
    if (Cell_5 < 0) //       .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n    Cell_5 = ", Cell_5, " .");
      Print ("    Cell_5 = ", Cell_5, " .");
      return (-1);
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return (-1);
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return (-1);
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return (-1);
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return (-1);
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return (-1);
     }
    if (Cell_5 > (SizeDimension_5 - 1)) //      .
     {
      Comment (" \"IntArrayDynamicDimension6()\".\n   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5, ".");
      Print ("   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5);
      return (-1);
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  if (SizeDimension_5 == 0) SizeDim_5 = 1;
  else SizeDim_5 = SizeDimension_5;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_1 + SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_2 + SizeDim_4 * SizeDim_5 * Cell_3 + SizeDim_5 * Cell_4 + Cell_5; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        for (f = 0; f < SizeDim_5; f++)
         Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "][", f, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * b + SizeDim_3 * SizeDim_4 * SizeDim_5 * c + SizeDim_4 * SizeDim_5 * d + SizeDim_5 * e + f]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//      .
//16== "     ".============================================================================================================================
string StringArrayDynamicDimension2 (bool    Write_Read,      //  true/false - /.
                                     bool    CheckingERROR,   //  true/false - /   .
                                     bool    PRINT,           //  true/false - /        .
                                     int     SizeDimension_0, //    .
                                     int     SizeDimension_1, //    .
                                     int     Cell_0,          //     .
                                     int     Cell_1,          //     .
                                     string& Value,           //    /.
                                     string& Array[])         // 1-        .
 {
  int a, b;      //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return ("-1");
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return ("-1");
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return ("-1");
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension2()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return ("-1");
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1);
  Cell = SizeDim_1 * Cell_0 + Cell_1;          //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     Print ("Array[", a,"][", b, "] = ", Array[SizeDim_1 * a + b]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//17== "     ".=============================================================================================================================
string StringArrayDynamicDimension3 (bool    Write_Read,      //  true/false - /
                                     bool    CheckingERROR,   //  true/false - /   
                                     bool    PRINT,           //  true/false - /        
                                     int     SizeDimension_0, //    
                                     int     SizeDimension_1, //    
                                     int     SizeDimension_2, //    
                                     int     Cell_0,          //     
                                     int     Cell_1,          //     
                                     int     Cell_2,          //     
                                     string& Value,           //    /
                                     string& Array[])         // 1-        
 {
  int a, b, c;   //   .
  int Cell;      //     .
  int SizeDim_1; //  .
  int SizeDim_2; //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return ("-1");
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return ("-1");
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return ("-1");
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return ("-1");
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return ("-1");
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return ("-1");
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension3()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return ("-1");
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2);
  Cell = SizeDim_1 * SizeDim_2 * Cell_0 + SizeDim_2 * Cell_1 + Cell_2; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      Print ("Array[", a,"][", b, "][", c, "] = ", Array[SizeDim_1 * SizeDim_2 * a + SizeDim_2 * b + c]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//18== "     ".=========================================================================================================================
string StringArrayDynamicDimension4 (bool    Write_Read,      //  true/false - /.
                                     bool    CheckingERROR,   //  true/false - /   .
                                     bool    PRINT,           //  true/false - /        .
                                     int     SizeDimension_0, //    .
                                     int     SizeDimension_1, //    .
                                     int     SizeDimension_2, //    .
                                     int     SizeDimension_3, //    .
                                     int     Cell_0,          //     .
                                     int     Cell_1,          //     .
                                     int     Cell_2,          //     .
                                     int     Cell_3,          //     .
                                     string& Value,           //    /.
                                     string& Array[])         // 1-        .
 {
  int a, b, c, d; //   .
  int Cell;       //     .
  int SizeDim_1;  //  .
  int SizeDim_2;  //  .
  int SizeDim_3;  //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return ("-1");
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return ("-1");
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return ("-1");
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return ("-1");
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return ("-1");
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return ("-1");
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return ("-1");
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return ("-1");
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return ("-1");
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension4()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return ("-1");
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * Cell_0 + SizeDim_2 * SizeDim_3 * Cell_1 + SizeDim_3 * Cell_2 + Cell_3; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       Print ("Array[", a,"][", b, "][", c, "][", d, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * a + SizeDim_2 * SizeDim_3 * b + SizeDim_3 * c + d]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//19== "     ".============================================================================================================================
string StringArrayDynamicDimension5 (bool    Write_Read,      //  true/false - /.
                                     bool    CheckingERROR,   //  true/false - /   .
                                     bool    PRINT,           //  true/false - /        .
                                     int     SizeDimension_0, //    .
                                     int     SizeDimension_1, //    .
                                     int     SizeDimension_2, //    .
                                     int     SizeDimension_3, //    .
                                     int     SizeDimension_4, //    .
                                     int     Cell_0,          //     .
                                     int     Cell_1,          //     .
                                     int     Cell_2,          //     .
                                     int     Cell_3,          //     .
                                     int     Cell_4,          //     .
                                     string& Value,           //    /.
                                     string& Array[])         // 1-        .
 {
  int a, b, c, d, e; //   .
  int Cell;          //     .
  int SizeDim_1;     //  .
  int SizeDim_2;     //  .
  int SizeDim_3;     //  .
  int SizeDim_4;     //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return ("-1");
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return ("-1");
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return ("-1");
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return ("-1");
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return ("-1");
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return ("-1");
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return ("-1");
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return ("-1");
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return ("-1");
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return ("-1");
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return ("-1");
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return ("-1");
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension5()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return ("-1");
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * Cell_1 + SizeDim_3 * SizeDim_4 * Cell_2 + SizeDim_4 * Cell_3 + Cell_4; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * b + SizeDim_3 * SizeDim_4 * c + SizeDim_4 * d + e]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//20== "     ".===========================================================================================================================
string StringArrayDynamicDimension6 (bool    Write_Read,      //  true/false - /.
                                     bool    CheckingERROR,   //  true/false - /   .
                                     bool    PRINT,           //  true/false - /        .
                                     int     SizeDimension_0, //    .
                                     int     SizeDimension_1, //    .
                                     int     SizeDimension_2, //    .
                                     int     SizeDimension_3, //    .
                                     int     SizeDimension_4, //    .
                                     int     SizeDimension_5, //    .
                                     int     Cell_0,          //     .
                                     int     Cell_1,          //     .
                                     int     Cell_2,          //     .
                                     int     Cell_3,          //     .
                                     int     Cell_4,          //     .
                                     int     Cell_5,          //     .
                                     string& Value,           //    /.
                                     string& Array[])         // 1-        .
 {
  int a, b, c, d, e, f; //   .
  int Cell;             //     .
  int SizeDim_1;        //  .
  int SizeDim_2;        //  .
  int SizeDim_3;        //  .
  int SizeDim_4;        //  .
  int SizeDim_5;        //  .
  //----  .--------------------------------------------------------------------------------------------------------------------------------------------------------------
  if (CheckingERROR == true)
   {
    //     .
    if (SizeDimension_0 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_0 = ", SizeDimension_0, " .");
      Print (" SizeDimension_0 = ", SizeDimension_0, " .");
      return ("-1");
     }
    if (SizeDimension_1 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_1 = ", SizeDimension_1, " .");
      Print (" SizeDimension_1 = ", SizeDimension_1, " .");
      return ("-1");
     }
    if (SizeDimension_2 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_2 = ", SizeDimension_2, " .");
      Print (" SizeDimension_2 = ", SizeDimension_2, " .");
      return ("-1");
     }
    if (SizeDimension_3 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_3 = ", SizeDimension_3, " .");
      Print (" SizeDimension_3 = ", SizeDimension_3, " .");
      return ("-1");
     }
    if (SizeDimension_4 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_4 = ", SizeDimension_4, " .");
      Print (" SizeDimension_4 = ", SizeDimension_4, " .");
      return ("-1");
     }
    if (SizeDimension_5 < 0) //     .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n SizeDimension_5 = ", SizeDimension_5, " .");
      Print (" SizeDimension_5 = ", SizeDimension_5, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_0 = ", Cell_0, " .");
      Print ("    Cell_0 = ", Cell_0, " .");
      return ("-1");
     }
    if (Cell_1 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_1 = ", Cell_1, " .");
      Print ("    Cell_1 = ", Cell_1, " .");
      return ("-1");
     }
    if (Cell_2 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_2 = ", Cell_2, " .");
      Print ("    Cell_2 = ", Cell_2, " .");
      return ("-1");
     }
    if (Cell_3 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_3 = ", Cell_3, " .");
      Print ("    Cell_3 = ", Cell_3, " .");
      return ("-1");
     }
    if (Cell_4 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_4 = ", Cell_4, " .");
      Print ("    Cell_4 = ", Cell_4, " .");
      return ("-1");
     }
    if (Cell_5 < 0) //       .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n    Cell_5 = ", Cell_5, " .");
      Print ("    Cell_5 = ", Cell_5, " .");
      return ("-1");
     }
    //     .
    if (Cell_0 > (SizeDimension_0 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0, ".");
      Print ("   Cell_0 = ", Cell_0, ".     SizeDimension_0 = ", SizeDimension_0);
      return ("-1");
     }
    if (Cell_1 > (SizeDimension_1 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1, ".");
      Print ("   Cell_1 = ", Cell_1, ".     SizeDimension_1 = ", SizeDimension_1);
      return ("-1");
     }
    if (Cell_2 > (SizeDimension_2 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2, ".");
      Print ("   Cell_2 = ", Cell_2, ".     SizeDimension_2 = ", SizeDimension_2);
      return ("-1");
     }
    if (Cell_3 > (SizeDimension_3 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3, ".");
      Print ("   Cell_3 = ", Cell_3, ".     SizeDimension_3 = ", SizeDimension_3);
      return ("-1");
     }
    if (Cell_4 > (SizeDimension_4 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4, ".");
      Print ("   Cell_4 = ", Cell_4, ".     SizeDimension_4 = ", SizeDimension_4);
      return ("-1");
     }
    if (Cell_5 > (SizeDimension_5 - 1)) //      .
     {
      Comment (" \"StringArrayDynamicDimension6()\".\n   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5, ".");
      Print ("   Cell_5 = ", Cell_5, ".     SizeDimension_5 = ", SizeDimension_5);
      return ("-1");
     }
   }
  //----        .---------------------------------------------------------------------------------------------------------------------
  if (SizeDimension_1 == 0) SizeDim_1 = 1;
  else SizeDim_1 = SizeDimension_1;
  if (SizeDimension_2 == 0) SizeDim_2 = 1;
  else SizeDim_2 = SizeDimension_2;
  if (SizeDimension_3 == 0) SizeDim_3 = 1;
  else SizeDim_3 = SizeDimension_3;
  if (SizeDimension_4 == 0) SizeDim_4 = 1;
  else SizeDim_4 = SizeDimension_4;
  if (SizeDimension_5 == 0) SizeDim_5 = 1;
  else SizeDim_5 = SizeDimension_5;
  ArrayResize (Array, SizeDimension_0 * SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5);
  Cell = SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_0 + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_1 + SizeDim_3 * SizeDim_4 * SizeDim_5 * Cell_2 + SizeDim_4 * SizeDim_5 * Cell_3 + SizeDim_5 * Cell_4 + Cell_5; //     .
  //----/.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  //     .
  if (PRINT == true)
   for (a = 0; a < SizeDimension_0; a++)
    for (b = 0; b < SizeDim_1; b++)
     for (c = 0; c < SizeDim_2; c++)
      for (d = 0; d < SizeDim_3; d++)
       for (e = 0; e < SizeDim_4; e++)
        for (f = 0; f < SizeDim_5; f++)
         Print ("Array[", a,"][", b, "][", c, "][", d, "][", e, "][", f, "] = ", Array[SizeDim_1 * SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * a + SizeDim_2 * SizeDim_3 * SizeDim_4 * SizeDim_5 * b + SizeDim_3 * SizeDim_4 * SizeDim_5 * c + SizeDim_4 * SizeDim_5 * d + SizeDim_5 * e + f]);
  //   .
  if (Write_Read == false) return (Array[Cell]);
  //   .
  if (Write_Read == true) Array[Cell] = Value;
  //   ,    .
  return (Array[Cell]);
 }
//===============================================================================================================================================================================================
//
/*
//+-----------------------------------------------------------------------------------+
//|                                                       Checking_Dynamic_Arrays.mq4 |
//|                                                       Copyright  Zhunko          |
//|08.01.2008                                             zhunko@mail.ru              |
//+-----------------------------------------------------------------------------------+
//|        .   |
//+-----------------------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "zhunko@mail.ru"
#property show_inputs
#import "ZH_Dynamic_Arrays_Lib.ex4"
 int IntArrayDynamicDimension4 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int SizeDimension_3, int Cell_0, int Cell_1, int Cell_2, int Cell_3, int Value, int Array[]);
#import
extern bool Write_Read = false;
extern int  Cell_0     = 0;
extern int  Cell_1     = 0;
extern int  Cell_2     = 0;
extern int  Cell_3     = 0;
extern int  SizeDim_0  = 2;
extern int  SizeDim_1  = 4;
extern int  SizeDim_2  = 6;
extern int  SizeDim_3  = 8;
//----
int a, b, c, d, n; //   .
int Array[];
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
 {
  int Value;
  if (Write_Read == false)
   {
    ArrayResize (Array, SizeDim_0 * SizeDim_1 * SizeDim_2 * SizeDim_3);
    for (a = 0; a < SizeDim_0 * SizeDim_1 * SizeDim_2 * SizeDim_3; a++) Array[a] = a;
    //  .
    for (a = 0, n = 0; a < SizeDim_0; a++)
     for (b = 0; b < SizeDim_1; b++)
      for (c = 0; c < SizeDim_2; c++)
       for (d = 0; d < SizeDim_3; d++, n++) Alert ("Array[", n, "] = ", IntArrayDynamicDimension4 (Write_Read, true, true, SizeDim_0, SizeDim_1, SizeDim_2, SizeDim_3, a, b, c, d, Value, Array));
    Comment (IntArrayDynamicDimension4 (Write_Read, true, true, SizeDim_0, SizeDim_1, SizeDim_2, SizeDim_3, Cell_0, Cell_1, Cell_2, Cell_3, Value, Array));
   }
  else
   {
    for (a = 0, n = 0; a < SizeDim_0; a++)
     for (b = 0; b < SizeDim_1; b++)
      for (c = 0; c < SizeDim_2; c++)
       for (d = 0; d < SizeDim_3; d++, n++) IntArrayDynamicDimension4 (Write_Read, true, true, SizeDim_0, SizeDim_1, SizeDim_2, SizeDim_3, a, b, c, d, n, Array);
    //  .
    for (a = 0; a < SizeDim_0 * SizeDim_1 * SizeDim_2 * SizeDim_3; a++) Alert ("Array[", a, "] = ", Array[a]);
   }
  //----
  return(0);
 }
//+------------------------------------------------------------------+
//+-----------------------------------------------------------------------------------+
//|                                                       Checking_Dynamic_Arrays.mq4 |
//|                                                       Copyright  Zhunko          |
//|08.01.2008                                             zhunko@mail.ru              |
//+-----------------------------------------------------------------------------------+
//|        .   |
//+-----------------------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "zhunko@mail.ru"
#property show_inputs
#import "ZH_Dynamic_Arrays_Lib.ex4"
 double DoubleArrayDynamicDimension3 (bool Write_Read, bool CheckingERROR, bool PRINT, int SizeDimension_0, int SizeDimension_1, int SizeDimension_2, int Cell_0, int Cell_1, int Cell_2, double Value, double Array[]);
#import
extern bool Write_Read = false;
extern int  Cell_0     = 0;
extern int  Cell_1     = 0;
extern int  Cell_2     = 0;
extern int  Cell_3     = 0;
extern int  SizeDim_0  = 10000;
extern int  SizeDim_1  = 100;
extern int  SizeDim_2  = 9;
extern int  SizeDim_3  = 1;
//----
int      a, b, c, d, n; //   .
string   str1, str2;
double   Array[];
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
 {
  datetime time;
  double   Value;
  //----
  if (Write_Read == false)
   {
    ArrayResize (Array, SizeDim_0 * SizeDim_1 * SizeDim_2);
    time = TimeLocal();
    for (a = 0; a < SizeDim_0 * SizeDim_1 * SizeDim_2 * SizeDim_3; a++) Array[a] = a;
    str1 = TimeToStr (TimeLocal() - time, TIME_MINUTES|TIME_SECONDS);
    Comment ("    = ", str1);
    //  .
    time = TimeLocal();
    for (a = 0, n = 0; a < SizeDim_0; a++)
     for (b = 0; b < SizeDim_1; b++)
      for (c = 0; c < SizeDim_2; c++)
//       for (d = 0; d < SizeDim_3; d++, n++)
        {
         Value = DoubleArrayDynamicDimension3 (Write_Read, false, false, SizeDim_0, SizeDim_1, SizeDim_2, a, b, c, Value, Array);
//         Alert ("Array[", n, "] = ", IntArrayDynamicDimension3 (Write_Read, false, false, SizeDim_0, SizeDim_1, SizeDim_2, a, b, c, Value, Array));
        }
    str2 = TimeToStr (TimeLocal() - time, TIME_MINUTES|TIME_SECONDS);
    Comment ("    = ", str1, "\n    = ", str2);
//    Comment (DoubleArrayDynamicDimension3 (Write_Read, false, false, SizeDim_0, SizeDim_1, SizeDim_2, Cell_0, Cell_1, Cell_2, Value, Array));
   }
  else
   {
    time = TimeLocal();
    for (a = 0, n = 0; a < SizeDim_0; a++)
     for (b = 0; b < SizeDim_1; b++)
      for (c = 0; c < SizeDim_2; c++, n++)
//       for (d = 0; d < SizeDim_3; d++)
         {
          DoubleArrayDynamicDimension3 (Write_Read, false, false, SizeDim_0, SizeDim_1, SizeDim_2, a, b, c, n, Array);
         }
    str1 = TimeToStr (TimeLocal() - time, TIME_MINUTES|TIME_SECONDS);
    Comment ("    = ", str1);
    //  .
    time = TimeLocal();
    for (a = 0; a < SizeDim_0 * SizeDim_1 * SizeDim_2; a++)
     {
      Value = Array[a];
//      Alert ("Array[", a, "] = ", Array[a]);
     }
    str2 = TimeToStr (TimeLocal() - time, TIME_MINUTES|TIME_SECONDS);
    Comment ("    = ", str1, "\n    = ", str2);
   }
  //----
  return(0);
 }
//+------------------------------------------------------------------+
     .
    ,   .
              .
       .    .
   ,  .     .    .
       ,      4.
*/